package splash_screen_on_boot.java;

import javafx.concurrent.Task;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import uploading_to_bulletin_board.java.UploadingToBulletinBoardController;

import java.io.IOException;

/**
 * SplashScreenOnBootController starts the entry point into meerkat it displays the loading
 */
public class SplashScreenOnBootController {

    private static final String SPALSH_SCREEN_ON_BOOT_FXML_PATH = "../fxml/spalsh_screen_on_boot.fxml";
    private static final int TWO_SECONDS_TIMEOUT_IN_MILLISECONDS = 2000;

    /** The primary stage which displays data, should pass it to next controller **/
    private Stage currentStage;


    public SplashScreenOnBootController(Stage primaryStage) throws IOException
    {
        Parent splashScreenOnBootRoot = FXMLLoader.load(getClass().getResource(SPALSH_SCREEN_ON_BOOT_FXML_PATH));
        currentStage = primaryStage;
        currentStage.setScene(new Scene(splashScreenOnBootRoot, 565, 365));
        IntroSleep();
    }

    /**
     * After the splash screen displayed wait -
     * two seconds and than continue to StartUploadingToBulletinBoard
     */
    private void IntroSleep()
    {
        Task<Void> sleeper = new Task<Void>() {
            @Override
            protected Void call() throws Exception {
                Thread.sleep(TWO_SECONDS_TIMEOUT_IN_MILLISECONDS);
                return null;
            }
        };
        sleeper.setOnSucceeded(event -> {
            try {
                StartUploadingToBulletinBoard();
            } catch (IOException e) {
                System.out.println("Could not create new uploading to bulletin board scene!");
            }
        });
        new Thread(sleeper).start();
    }

    /**
     * Creates instance of uploading to bulletin board and set it as the scene
     */
    private void StartUploadingToBulletinBoard() throws IOException {
        new UploadingToBulletinBoardController(currentStage);
    }

    /**
     * Needed for normal output flow
     */
    public SplashScreenOnBootController(){}
}
